---
apiVersion: v1
kind: PersistentVolumeClaim
metadata:
    name: cluster-repositories
    namespace: yaook-bmc
spec:
    accessModes:
    - ReadWriteOnce
    storageClassName: local-storage
    resources:
        requests:
            storage: "1Gi"
---
apiVersion: v1
kind: Secret
metadata:
  name: netbox-token
  namespace: yaook-bmc
data:
  token: "{{ netbox_secret | b64encode }}"
---
apiVersion: v1
kind: Service
metadata:
    name: metal-controller
    namespace: yaook-bmc
spec:
    clusterIP: None
    selector:
        app.kubernetes.io/name: metal-controller
        app.kubernetes.io/instance: main
---
apiVersion: apps/v1
kind: StatefulSet
metadata:
    name: metal-controller
    namespace: yaook-bmc
spec:
    replicas: 1
    serviceName: metal-controller
    selector:
        matchLabels:
            app.kubernetes.io/name: metal-controller
            app.kubernetes.io/instance: main
    template:
        metadata:
            labels:
                app.kubernetes.io/name: metal-controller
                app.kubernetes.io/instance: main
        spec:
            volumes:
              - name: repositories
                persistentVolumeClaim:
                    claimName: cluster-repositories
              - name: vault-cert
                projected:
                    sources:
                      - secret:
                            name: vault-ca-internal
                            items:
                            - key: ca.crt
                              path: ca.crt
              - name: keystone-cert
                projected:
                  sources:
                    - secret:
                        name: root-ca
                        items:
                        - key: tls.crt
                          path: ca.crt
            containers:
              - name: metal-controller
                image: registry.yaook.cloud/yaook/metal-controller:{{ metal_controller_version }}
                imagePullPolicy: IfNotPresent
                command:
                  - bash
                  - -euo
                  - pipefail
                  - -c
                  - |
{% if yaook_k8s_ip6_enabled %}
                    export NETBOX_URL="http://[$NETBOX_SERVICE_HOST]:80/"
{% else %}
                    export NETBOX_URL="http://$NETBOX_SERVICE_HOST:80/"
{% endif %}
                    export OS_AUTH_URL="https://keystone.$NAMESPACE.svc:$KEYSTONE_SERVICE_PORT_INTERNAL/"
                    export OS_BAREMETAL_ENDPOINT="https://infra-ironic.$NAMESPACE.svc:$INFRA_IRONIC_SERVICE_PORT_API/"
                    export OS_BAREMETAL_INTROSPECTION_ENDPOINT="https://infra-ironic-inspector.$NAMESPACE.svc:$INFRA_IRONIC_INSPECTOR_SERVICE_PORT_API/"
                    export VAULT_ADDR="https://vault.$NAMESPACE.svc.cluster.local:8200/"
                    export VAULT_CACERT="/mnt/vault-cert/ca.crt"
                    export REQUESTS_CA_BUNDLE="/mnt/keystone-cert/ca.crt"
                    exec /entrypoint.sh metal_controller -vvv
                volumeMounts:
                  - name: repositories
                    mountPath: /var/lib/metal-controller
                  - name: vault-cert
                    mountPath: /mnt/vault-cert
                  - name: keystone-cert
                    mountPath: /mnt/keystone-cert
                envFrom:
                  - secretRef:
                      name: {{ keystone_secret_name }}
                env:
                  - name: NAMESPACE
                    valueFrom:
                      fieldRef:
                        fieldPath: metadata.namespace
                  - name: NETBOX_TOKEN
                    valueFrom:
                      secretKeyRef:
                        name: netbox-token
                        key: token
                  - name: YAOOK_DEPLOY_VAULT_ADDR
                    # this is the vault address under which the deployed *nodes* can reach the vault
                    # note that the vault CA is pushed toc the nodes, too (based on VAULT_CAPATH) so HTTPS will work securely out of the box
                    value: "https://vault-yaook.ymc.{{ cluster_name }}:32443"
                  - name: YAOOK_DEPLOY_PUBLIC_KEYS
                    # one or more (newline separated) SSH public keys to add to the default user
                    value: |
                      ssh-ed25519 AAAAC3NzaC1lZDI1NTE5AAAAII/NWTY8d4CpGsey23vlWHa4koaPLKEvXNFJ+v94M7AP iljashmelkin@630-705
                      ssh-ed25519 AAAAC3NzaC1lZDI1NTE5AAAAIJJIIqgnd6IR+GCpQSALg1aZLFCOXeQ7TgD9yfncxQC6 deployer@installnode
                      ssh-ed25519 AAAAC3NzaC1lZDI1NTE5AAAAIBAoQwk/p22sTsq77LFUB4r7ASsYKCnCd87DeuPZ9TVL lucas.trilken@cloudandheat.com
                      ssh-ed25519 AAAAC3NzaC1lZDI1NTE5AAAAIIlS9j/eJjKO5P8vkJmGkxYhiXq8VxYEY21o3+GjACHW maximilian.brandt
                  - name: YAOOK_DEPLOY_IMAGE
                    # URL to the image (must be reachable from within the PXE network; the image server deployed with ironic is typically a good choice)
                    value: "http://image.ymc.{{ cluster_name }}:32080/ubuntu22_raid.raw"
                  - name: YAOOK_DEPLOY_IMAGE_CHECKSUM
                    value: 51f636f9b2a1eccf68cc5ea35e2976f2
                  - name: YAOOK_APT_HASHICORP_REPO_URL
                    value: http://apt.releases.hashicorp.com
                  - name: YAOOK_APT_HASHICORP_GPG_KEY
                    value: |
                      -----BEGIN PGP PUBLIC KEY BLOCK-----
                      
                      mQINBGO9u+MBEADmE9i8rpt8xhRqxbzlBG06z3qe+e1DI+SyjscyVVRcGDrEfo+J
                      W5UWw0+afey7HFkaKqKqOHVVGSjmh6HO3MskxcpRm/pxRzfni/OcBBuJU2DcGXnG
                      nuRZ+ltqBncOuONi6Wf00McTWviLKHRrP6oWwWww7sYF/RbZp5xGmMJ2vnsNhtp3
                      8LIMOmY2xv9LeKMh++WcxQDpIeRohmSJyknbjJ0MNlhnezTIPajrs1laLh/IVKVz
                      7/Z73UWX+rWI/5g+6yBSEtj368N7iyq+hUvQ/bL00eyg1Gs8nE1xiCmRHdNjMBLX
                      lHi0V9fYgg3KVGo6Hi/Is2gUtmip4ZPnThVmB5fD5LzS7Y5joYVjHpwUtMD0V3s1
                      HiHAUbTH+OY2JqxZDO9iW8Gl0rCLkfaFDBS2EVLPjo/kq9Sn7vfp2WHffWs1fzeB
                      HI6iUl2AjCCotK61nyMR33rNuNcbPbp+17NkDEy80YPDRbABdgb+hQe0o8htEB2t
                      CDA3Ev9t2g9IC3VD/jgncCRnPtKP3vhEhlhMo3fUCnJI7XETgbuGntLRHhmGJpTj
                      ydudopoMWZAU/H9KxJvwlVXiNoBYFvdoxhV7/N+OBQDLMevB8XtPXNQ8ZOEHl22G
                      hbL8I1c2SqjEPCa27OIccXwNY+s0A41BseBr44dmu9GoQVhI7TsetpR+qwARAQAB
                      tFFIYXNoaUNvcnAgU2VjdXJpdHkgKEhhc2hpQ29ycCBQYWNrYWdlIFNpZ25pbmcp
                      IDxzZWN1cml0eStwYWNrYWdpbmdAaGFzaGljb3JwLmNvbT6JAlQEEwEIAD4CGwMF
                      CwkIBwIGFQoJCAsCBBYCAwECHgECF4AWIQR5iuxlTlwVQoyOQu6qFvy8piHnAQUC
                      Y728PQUJCWYB2gAKCRCqFvy8piHnAd16EADeBtTgkdVEvct40TH/9HKkR/Lc/ohM
                      rer6FFHdKmceJ6Ma8/Qm4nCO5C7c4+EPjsUXdhK5w8DSdC5VbKLJDY1EnDlmU5B1
                      wSFkGoYKoB8lUn30E77E33MTu2kfrSuF605vetq269CyBwIJV7oNN6311dW8iQ6z
                      IytTtlJbVr4YZ7Vst40/uR4myumk9bVBGEd6JhFAPmr/um+BZFhRf9/8xtOryOyB
                      GF2d+bc9IoAugpxwv0IowHEqkI4RpK2U9hvxG80sTOcmerOuFbmNyPwnEgtJ6CM1
                      bc8WAmObJiQcRSLbcgF+a7+2wqrUbCqRE7QoS2wjd1HpUVPmSdJN925c2uaua2A4
                      QCbTEg8kV2HiP0HGXypVNhZJt5ouo0YgR6BSbMlsMHniDQaSIP1LgmEz5xD4UAxO
                      Y/GRR3LWojGzVzBb0T98jpDgPtOu/NpKx3jhSpE2U9h/VRDiL/Pf7gvEIxPUTKuV
                      5D8VqAiXovlk4wSH13Q05d9dIAjuinSlxb4DVr8IL0lmx9DyHehticmJVooHDyJl
                      HoA2q2tFnlBBAFbN92662q8Pqi9HbljVRTD1vUjof6ohaoM+5K1C043dmcwZZMTc
                      7gV1rbCuxh69rILpjwM1stqgI1ONUIkurKVGZHM6N2AatNKqtBRdGEroQo1aL4+4
                      u+DKFrMxOqa5b7kCDQRjvbwTARAA0ut7iKLj9sOcp5kRG/5V+T0Ak2k2GSus7w8e
                      kFh468SVCNUgLJpLzc5hBiXACQX6PEnyhLZa8RAG+ehBfPt03GbxW6cK9nx7HRFQ
                      GA79H5B4AP3XdEdT1gIL2eaHdQot0mpF2b07GNfADgj99MhpxMCtTdVbBqHY8YEQ
                      Uq7+E9UCNNs45w5ddq07EDk+o6C3xdJ42fvS2x44uNH6Z6sdApPXLrybeun74C1Z
                      Oo4Ypre4+xkcw2q2WIhy0Qzeuw+9tn4CYjrhw/+fvvPGUAhtYlFGF6bSebmyua8Q
                      MTKhwqHqwJxpjftM3ARdgFkhlH1H+PcmpnVutgTNKGcy+9b/lu/Rjq/47JZ+5VkK
                      ZtYT/zO1oW5zRklHvB6R/OcSlXGdC0mfReIBcNvuNlLhNcBA9frNdOk3hpJgYDzg
                      f8Ykkc+4z8SZ9gA3g0JmDHY1X3SnSadSPyMas3zH5W+16rq9E+MZztR0RWwmpDtg
                      Ff1XGMmvc+FVEB8dRLKFWSt/E1eIhsK2CRnaR8uotKW/A/gosao0E3mnIygcyLB4
                      fnOM3mnTF3CcRumxJvnTEmSDcoKSOpv0xbFgQkRAnVSn/gHkcbVw/ZnvZbXvvseh
                      7dstp2ljCs0queKU+Zo22TCzZqXX/AINs/j9Ll67NyIJev445l3+0TWB0kego5Fi
                      UVuSWkMAEQEAAYkEcgQYAQgAJhYhBHmK7GVOXBVCjI5C7qoW/LymIecBBQJjvbwT
                      AhsCBQkJZgGAAkAJEKoW/LymIecBwXQgBBkBCAAdFiEE6wr14plJaVlvmYc+cG5m
                      g2nAhekFAmO9vBMACgkQcG5mg2nAhenPURAAimI0EBZbqpyHpwpbeYq3Pygg1bdo
                      IlBQUVoutaN1lR7kqGXwYH+BP6G40x79LwVy/fWV8gO7cDX6D1yeKLNbhnJHPBus
                      FJDmzDPbjTlyWlDqJoWMiPqfAOc1A1cHodsUJDUlA01j1rPTho0S9iALX5R50Wa9
                      sIenpfe7RVunDwW5gw6y8me7ncl5trD0LM2HURw6nYnLrxePiTAF1MF90jrAhJDV
                      +krYqd6IFq5RHKveRtCuTvpL7DlgVCtntmbXLbVC/Fbv6w1xY3A7rXko/03nswAi
                      AXHKMP14UutVEcLYDBXbDrvgpb2p2ZUJnujs6cNyx9cOPeuxnke8+ACWvpnWxwjL
                      M5u8OckiqzRRobNxQZ1vLxzdovYTwTlUAG7QjIXVvOk9VNp/ERhh0eviZK+1/ezk
                      Z8nnPjx+elThQ+r16EM7hD0RDXtOR1VZ0R3OL64AlZYDZz1jEA3lrGhvbjSIfBQk
                      T6mxKUsCy3YbElcOyuohmPRgT1iVDIZ/1iPL0Q0HGm4+EsWCdH6fAPB7TlHD8z2D
                      7JCFLihFDWs5lrZyuWMO9nryZiVjJrOLPcStgJYVd/MhRHR4hC6g09bgo25RMJ6f
                      gyzL4vlEB7aSUih7yjgL9s5DKXP2J71dAhIlF8nnM403R2xEeHyivnyeR/9Ifn7M
                      PJvUMUuoG+ZANSMkrw//XA31o//TVk9WsLD1Edxt5XZCoR+fS+Vz8ScLwP1d/vQE
                      OW/EWzeMRG15C0td1lfHvwPKvf2MN+WLenp9TGZ7A1kEHIpjKvY51AIkX2kW5QLu
                      Y3LBb+HGiZ6j7AaU4uYR3kS1+L79v4kyvhhBOgx/8V+b3+2pQIsVOp79ySGvVwpL
                      FJ2QUgO15hnlQJrFLRYa0PISKrSWf35KXAy04mjqCYqIGkLsz2qQCY2lGcD5k05z
                      bBC4TvxwVxv0ftl2C5Bd0ydl/2YM7GfLrmZmTijK067t4OO+2SROT2oYPDsMtZ6S
                      E8vUXvoGpQ8tf5Nkrn2t0zDG3UDtgZY5UVYnZI+xT7WHsCz//8fY3QMvPXAuc33T
                      vVdiSfP0aBnZXj6oGs/4Vl1Dmm62XLr13+SMoepMWg2Vt7C8jqKOmhFmSOWyOmRH
                      UZJR7nKvTpFnL8atSyFDa4o1bk2U3alOscWS8u8xJ/iMcoONEBhItft6olpMVdzP
                      CTrnCAqMjTSPlQU/9EGtp21KQBed2KdAsJBYuPgwaQeyNIvQEOXmINavl58VD72Y
                      2T4TFEY8dUiExAYpSodbwBL2fr8DJxOX68WH6e3fF7HwX8LRBjZq0XUwh0KxgHN+
                      b9gGXBvgWnJr4NSQGGPiSQVNNHt2ZcBAClYhm+9eC5/VwB+Etg4+1wDmggztiqE=
                      =FdUF
                      -----END PGP PUBLIC KEY BLOCK-----
                  - name: VAULT_AUTH_PATH
                    value: yaook/bmc
                  - name: VAULT_ROLE_ID
                    value: "{{ vault_role_id }}"
                  - name: VAULT_SECRET_ID
                    value: "{{ vault_secret_id }}"
                  - name: YAOOK_CLUSTER_MAP
                    # This maps the cluster name to a directory in the persistent volume where the cluster repository is held for that cluster.
                    value: |
                      {{ cluster_name }}: /var/lib/metal-controller/{{ cluster_name }}/
                  # Set this to true if you want the metal controller to keep the last configdrive generated for a cluster around in the cluster repository.
                  - name: YAOOK_DEPLOY_CONFIGDRIVE_DEBUG
                    value: "false"
                  #
              # If you want to use a dedicated editor of your choice to edit the toml
              # files per cluster (or do general file operations) a sidecar can be used
              # to bring in a container with an integrated editor
              #
              #- name: editor-sidecar
              #  image: <container image path of your editor container>
              #  imagePullPolicy: Always
              #  volumeMounts:
              #    - name: repositories
              #      mountPath: /var/lib/metal-controller

